@@ -24,12 +24,13 @@
 import java.util.List;
 import java.util.Locale;
 import java.util.Map;
 import java.util.TimeZone;
 import java.util.regex.PatternSyntaxException;
 
+import javax.script.ScriptException;
 import javax.servlet.ServletContext;
 import javax.servlet.http.HttpSession;
 
 import javolution.util.FastList;
 import javolution.util.FastMap;
 
@@ -400,18 +401,25 @@
     }
 
     @Deprecated
     public static class Script extends ModelScreenAction {
         protected String location;
         protected String method;
+        protected String value;
+        protected String type;
 
         public Script(ModelScreen modelScreen, Element scriptElement) {
             super (modelScreen, scriptElement);
             String scriptLocation = scriptElement.getAttribute("location");
-            this.location = WidgetWorker.getScriptLocation(scriptLocation);
-            this.method = WidgetWorker.getScriptMethodName(scriptLocation);
+            if (UtilValidate.isNotEmpty(scriptLocation)){
+                this.location = WidgetWorker.getScriptLocation(scriptLocation);
+                this.method = WidgetWorker.getScriptMethodName(scriptLocation);
+            } else {
+                this.value = scriptElement.getAttribute("value");
+                this.type = scriptElement.getAttribute("type");
+            }
         }
 
         @Override
         public void runAction(Map<String, Object> context) throws GeneralException {
             if (location.endsWith(".xml")) {
                 Map<String, Object> localContext = FastMap.newInstance();
@@ -421,12 +429,18 @@
                 try {
                     SimpleMethod.runSimpleMethod(location, method, methodContext);
                     context.putAll(methodContext.getResults());
                 } catch (MiniLangException e) {
                     throw new GeneralException("Error running simple method at location [" + location + "]", e);
                 }
+            } else if (UtilValidate.isNotEmpty(value)) {
+                try {
+                    ScriptUtil.executeGroovyScript(value, context);
+                } catch (ScriptException e) {
+                    e.printStackTrace();
+                }
             } else {
                 ScriptUtil.executeScript(this.location, this.method, context);
             }
         }
     }
 
